import akka.actor.TypedActor;
import akka.actor.TypedActorFactory;

public class Increment {

  public static void main(String[] args) {

    final Counter counter =
      TypedActor.newInstance(Counter.class, CounterImpl.class);

    Drone[] drones = new Drone[6];

    for (int i = 0; i < 6; i++) {
      drones[i] =
        TypedActor.newInstance(
          Drone.class,
          new TypedActorFactory() {
            public TypedActor create() {
              return new DroneImpl(counter);
            }
          });
    }

    for (int i = 0; i < 6; i++) {
      drones[i].go();
    }
    try {
      Thread.sleep(1000);
    } catch (Exception ex) {
    }

    System.out.println("The final count is: " + counter.getCount());

    TypedActor.stop(counter);
    for (int i = 0; i < 6; i++) {
      TypedActor.stop(drones[i]);
    }
  }

}
